import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Enigma here.
 * 
 * @author Taylor Born
 * @version February 2010
 */
public class Enigma  extends World
{
    private Logo myLogo = new Logo();
    private boolean started = false;
    private String keys = "";
    private String message = "";
    private int delete;
    private int cursor = 0;
    private int blink = 0;
    private button btnCode = new button("Code", 40, 5);
    private String code = "";
    private int error;
    private button btnSwitch = new button("", 20, 1);
    private boolean typing = true;
    
    //private int again;
    private int[] arrows = new int[4];
    
    private static final int CODE_ID = 9;

    public Enigma()
    {
        super(400, 300, 1);
        GreenfootImage back = new GreenfootImage(400, 300);
        back.fill();
        setBackground(back);
        CodeKeyUser.enter();
        Greenfoot.start();
    }
    public void act()
    {
        if (myLogo != null)
        {
            if (!started && Greenfoot.mouseMoved(this))
            {
                addObject(myLogo, 200, 150);
                started = true;
            }
            if (myLogo != null)
                if (myLogo.done())
                {
                    removeObject(myLogo);
                    myLogo = null;
                    GreenfootImage pic = new GreenfootImage(400, 300);
                    pic.fill();
                    setBackground(pic);
                    addObject(btnCode, 60, 130);
                    addObject(btnSwitch, 20, 130);
                }
        }
        else
        {
            if (typing)
            {
                for (int i = 0; i < 10; i++)
                {
                    if (Greenfoot.isKeyDown(i + ""))
                    {
                        if (!keys.contains(i + "") && code.length() < 256)
                        {
                            message = message.substring(0, cursor) + i + message.substring(cursor); //code += i;
                            keys += i;
                            cursor++;
                        }
                    }
                    else
                        keys = keys.replace(i + "", "");
                }
                for (int i = 'A'; i <= 'Z'; i++)
                {
                    if (Greenfoot.isKeyDown((char)i + ""))
                    {
                        if (!keys.contains((char)i + "") && message.length() < 120)
                        {
                            message = message.substring(0, cursor) + (char)i + message.substring(cursor);//message += (char)i;
                            keys += (char)i;
                            cursor++;
                        }
                    }
                    else
                        keys = keys.replace((char)i + "", "");
                }
                if (Greenfoot.isKeyDown("space"))
                {
                    if (!keys.contains(" ") && message.length() < 120)
                    {
                        message = message.substring(0, cursor) + " " + message.substring(cursor); //message += " ";
                        keys += " ";
                        cursor++;
                    }
                }
                else
                    keys = keys.replace(" ", "");
                for (int i = 0; i < 10; i++)
                {
                    if (Greenfoot.isKeyDown(i + ""))
                    {}
                }
                if (Greenfoot.isKeyDown("-"))
                {}
                if (Greenfoot.isKeyDown(","))
                {}
            }
            else
            {
                for (int i = 0; i < 10; i++)
                {
                    if (Greenfoot.isKeyDown(i + ""))
                    {
                        if (!keys.contains(i + "") && code.length() < 256)
                        {
                            code = code.substring(0, cursor) + i + code.substring(cursor); //code += i;
                            keys += i;
                            cursor++;
                        }
                    }
                    else
                        keys = keys.replace(i + "", "");
                }
                if (Greenfoot.isKeyDown("-"))
                {
                    if (!keys.contains("-") && code.length() < 256)
                    {
                        code = code.substring(0, cursor) + "-" + code.substring(cursor); //code += "-";
                        keys += "-";
                        cursor++;
                    }
                }
                else
                    keys = keys.replace("-", "");
                if (Greenfoot.isKeyDown("_"))
                {
                    if (!keys.contains("_") && code.length() < 256)
                    {
                        code = code.substring(0, cursor) + "_" + code.substring(cursor);
                        keys += "_";
                        cursor++;
                    }
                }
                else
                    keys = keys.replace("_", "");
                if (Greenfoot.isKeyDown(","))
                {
                    if (!keys.contains(",") && code.length() < 256)
                    {
                        code = code.substring(0, cursor) + "," + code.substring(cursor); //code += ",";
                        keys += ",";
                        cursor++;
                    }
                }
                else
                    keys = keys.replace(",", "");
                for (int i = 'A'; i <= 'Z'; i++)
                {
                    if (Greenfoot.isKeyDown((char)i + ""))
                    {}
                }
                if (Greenfoot.isKeyDown("space"))
                {}
            }
            if (Greenfoot.isKeyDown("backspace"))
            {
                if (!keys.contains("*"))
                    delete = -15;
                delete++;
                if ((delete > 0 || !keys.contains("*")) && cursor > 0)
                {
                    if (typing)
                        message = message.substring(0, cursor - 1) + message.substring(cursor); //message = message.substring(0, message.length() - 1);
                    else
                        code = code.substring(0, cursor - 1) + code.substring(cursor); //code = code.substring(0, code.length() - 1);
                    keys += "*";
                    cursor--;
                }
            }
            else
                keys = keys.replace("*", "");
            if (Greenfoot.isKeyDown("."))
            {
                if (!keys.contains(".") && ((message.length() < 120 && typing) || (code.length() < 256 && !typing)))
                {
                    if (typing)
                        message = message.substring(0, cursor) + "." + message.substring(cursor); //message += ".";
                    else
                        code = code.substring(0, cursor) + "." + code.substring(cursor); //code += ".";
                    keys += ".";
                    cursor++;
                }
            }
            else
                keys = keys.replace(".", "");
            if (Greenfoot.isKeyDown("left"))
            {
                if (!keys.contains("<"))
                    arrows[0] = -15;
                arrows[0]++;
                if ((arrows[0] > 0 || !keys.contains("<")) && cursor > 0)
                    cursor--;
                keys += "<";
            }
            else
                keys = keys.replace("<", "");
            if (Greenfoot.isKeyDown("right"))
            {
                if (!keys.contains(">"))
                    arrows[1] = -15;
                arrows[1]++;
                if ((arrows[1] > 0 || !keys.contains(">")) && ((cursor < message.length() && typing) || (cursor < code.length() && !typing)))
                    cursor++;
                keys += ">";
            }
            else
                keys = keys.replace(">", "");
            if (Greenfoot.isKeyDown("up"))
            {
                if (!keys.contains("/"))
                    arrows[2] = -15;
                arrows[2]++;
                if ((arrows[2] > 0 || !keys.contains("/")) && cursor - 40 > -1)
                    cursor -= 40;
                keys += "/";
            }
            else 
                keys = keys.replace("/", "");
            if (Greenfoot.isKeyDown("down"))
            {
                if (!keys.contains("\\"))
                    arrows[3] = -15;
                arrows[3]++;
                if ((arrows[3] > 0 || !keys.contains("\\")) && ((cursor + 40 < message.length() + 1 && typing) || (cursor + 40 < code.length() + 1 && !typing)))
                    cursor += 40;
                keys += "\\";
            }
            else 
                keys = keys.replace("\\", "");
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if (Greenfoot.mouseClicked(btnCode))
            {
                if (!message.isEmpty())
                    if (CodeGenerator.haveUser())
                    {
                        removeObjects(getObjects(CodeDisplay.class));
                        addObject(new CodeDisplay(CODE_ID), getWidth() / 2, 6);
                    }
                if (typing) // Encrypting
                {
                    String t = "";
        
                    for (int i = 0; i < message.length(); i++)
                    {
                        // Replace spaces with '--'
                        if (message.charAt(i) == ' ')
                            t += "--";
                        // Replace periods with '..'
                        else if (message.charAt(i) == '.')
                            t += "..";
                        else if (message.charAt(i) >= '0' && message.charAt(i) <= '9')
                        {
                            int n = (message.charAt(i) - '0') - 5;
                            if (n < 0)
                                n += 10;
                            t += "_" + n;
                        }
                        else
                        {
                            int n = message.charAt(i);
                            
                            // Check which side of alphabet, and replace it with its mirror letter
                            if (n < 'N')
                                n = 'Z' - n + 'A';
                            else
                                n = 'A' + 'Z' - n;
                            
                            // Check if letter is even (advance 2 letters) or odd (advance negatively 2 letters) - wrapping A-Z
                            if (n % 2 == 0)
                            {
                                n += 2;
                                if (n > 'Z')
                                    n = n - 'Z' + 'A' - 1;
                            }
                            else
                            {
                                n -= 2;
                                if (n < 'A')
                                    n = n - 'A' + 'Z' + 1;
                            }
                            
                            t += n % 10;
                            t += (n - n % 10) / 10;
                        }
                    }
                    
                    // Find a square (with even side length) that fits all the characters of t
                    int n;
                    for (n = 2; n * n < t.length(); n += 2)
                    {}
                    
                    // Add enough ',' to fill square
                    for (int i = 0; t.length() < n * n; t += ",")
                    {}
                    
                    // Add chars in square by algorithm
                    // Example: (4x4 square)
                    //
                    // 1 13  3  5
                    // 6 10 14 12
                    // 9 15 11  7
                    // 8  2 16  4
                    //
                    // 1-4   is added when i=0 (i%2=0)
                    // 5-8   is added when i=1 (i%2=1)
                    // 9-12  is added when i=2 (i%2=0)
                    // 13-16 is added when i=3 (i%2=1)
                    //
                    char[][] b = new char[n][n];
                    for (int i = 0; i < n; i++)
                    {
                        if (i % 2 == 0)
                        {
                            for (int k = 0; k < n; k++)
                            {
                                if (k % 2 == 0)
                                    b[i][k] = t.charAt(i * n + k);
                                else
                                    b[(n - 1) - i][k] = t.charAt(i * n + k);
                            }
                        }
                        else
                        {
                            for (int k = 0; k < n; k++)
                            {
                                if (k % 2 == 0)
                                    b[k][(n - 1) - (i - 1)] = t.charAt(i * n + k);
                                else
                                    b[k][i - 1] = t.charAt(i * n + k);
                            }
                        }
                    }
                    
                    // Read square left to right, row by row
                    String m = "";
                    for (int i = 0; i < b.length; i++)
                    {
                        for (int k = 0; k < b[0].length; k++)
                            m += b[i][k];
                    }
                    code = m;
                }
                else // Decrypting
                {
                    try
                    {
                        if (code.length() > 0 && Math.sqrt(code.length()) % 1 == 0 && Math.sqrt(code.length()) % 2 == 0)
                        {
                            // Fill square left to right, row by row
                            int square = (int)Math.sqrt(code.length());
                            String[][] b = new String[square][square];
                            for (int i = 0; i < square; i++)
                                for (int k = 0; k < square; k++)
                                    b[i][k] = code.substring(i * square + k, i * square + k + 1);
                            
                            // Read square by algorithm described in Encryption
                            String t = "";
                            for (int i = 0; i < square; i++)
                            {
                                if (i % 2 == 0)
                                {
                                    for (int k = 0; k < square; k++)
                                    {
                                        if (k % 2 == 0)
                                            t += b[i][k];
                                        else
                                            t += b[(square - 1) - i][k];
                                    }
                                }
                                else
                                {
                                    for (int k = 0; k < square; k++)
                                    {
                                        if (k % 2 == 0)
                                            t += b[k][(square - 1) - (i - 1)];
                                        else
                                            t += b[k][i - 1];
                                    }
                                }
                            }
                            
                            // Get rid of filler
                            t = t.replace(",", "");
                            
                            String temp = "";
                            while (!t.isEmpty())
                            {
                                if (t.startsWith("--"))
                                    temp += " ";
                                else if (t.startsWith(".."))
                                    temp += ".";
                                else if (t.charAt(0) == '_')
                                {
                                    int n = Integer.parseInt(t.substring(1, 2)) + 5;
                                    if (n > 9)
                                        n -= 10;
                                    temp += n;
                                }
                                else
                                {
                                    int num = Integer.parseInt(t.substring(0, 1));
                                    num += Integer.parseInt(t.substring(1, 2)) * 10;
                                    if (num % 2 == 0)
                                    {
                                        num -= 2;
                                        if (num < 'A')
                                            num = num - 'A' + 'Z' + 1;
                                    }
                                    else
                                    {
                                        num += 2;
                                        if (num > 'Z')
                                            num = num - 'Z' + 'A' - 1;
                                    }
                                    if (num < 'A' || num > 'Z')
                                        error = 5;
                                    
                                    if (num < 'N')
                                        num = 'Z' - num + 'A';
                                    else
                                        num = 'A' + 'Z' - num;
//                                     if ((num < 'A' || num > 'Z') && num != ' ' && num != '.')
//                                         error = 5;
                                    
                                    temp += (char)num;
                                }
                                t = t.substring(2);
                            }
                            if (error == 0)
                                message = temp;
                        }
                        else
                            error = 5;
                    }
                    catch (Exception ex)
                    {
                        error = 5;
                    }
                }
            }
            else if (Greenfoot.mouseClicked(btnSwitch))
            {
                removeObject(btnCode);
                if (typing)
                {
                    btnCode = new button("Decode", 52, 5);
                    cursor = code.length();
                }
                else
                {
                    btnCode = new button("Code", 40, 5);
                    cursor = message.length();
                }
                typing = !typing;
                addObject(btnCode, 60, 130);
            }
            GreenfootImage pic = new GreenfootImage(400, 300);
            if (error > 0)
            {
                pic.setColor(Color.RED);
                error--;
            }
            pic.fill();
            pic.setFont(new Font("Courier New", 15, 15));
            pic.setColor(Color.WHITE);
            String s = message;
            for (int i = 0; s.length() > 0; i++)
            {
                if (s.length() > 40)
                {
                    pic.drawString(s.substring(0, 40), 20, 50 + 20 * i);
                    s = s.substring(40);
                }
                else
                {
                    pic.drawString(s, 20, 50 + 20 * i);
                    s = "";
                }
            }
            blink++;
            if (blink < 10 || Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("backspace"))
            {
                if (typing)
                    pic.drawLine(20 + 9 * (cursor % 40), 39 + 20 * (cursor - cursor % 40) / 40, 20 + 9 * (cursor % 40), 51 + 20 * (cursor - cursor % 40) / 40);
                else
                    pic.drawLine(20 + 9 * (cursor % 40), 149 + 20 * (cursor - cursor % 40) / 40, 20 + 9 * (cursor % 40), 161 + 20 * (cursor - cursor % 40) / 40);
                if (blink == 20)
                    blink = 0;
            }
            else if (blink == 20)
                blink = 0;
            s = code;
            for (int i = 0; s.length() > 0; i++)
            {
                if (s.length() > 40)
                {
                    pic.drawString(s.substring(0, 40), 20, 160 + 20 * i);
                    s = s.substring(40);
                }
                else
                {
                    pic.drawString(s, 20, 160 + 20 * i);
                    s = "";
                }
            }
            setBackground(pic);
        }
    }
}